Index: protocols/jabber/jabber.c
===================================================================
--- protocols/jabber/jabber.c	(revision a81d679654e36055ce9913cd7541885b41380947)
+++ protocols/jabber/jabber.c	(revision 767a148faa35c18cdf4da77b5919a2f6e2df868a)
@@ -57,4 +57,6 @@
 	set_t *s;
 	char str[16];
+	
+	s = set_add( &acc->set, "activity_timeout", "600", set_eval_int, acc );
 	
 	g_snprintf( str, sizeof( str ), "%d", jabber_port_list[0] );
@@ -321,5 +323,5 @@
 		bud = jabber_buddy_by_ext_jid( ic, who, 0 );
 	else
-		bud = jabber_buddy_by_jid( ic, who, 0 );
+		bud = jabber_buddy_by_jid( ic, who, GET_BUDDY_BARE_OK );
 	
 	node = xt_new_node( "body", message, NULL );
@@ -366,15 +368,7 @@
 static void jabber_get_info( struct im_connection *ic, char *who )
 {
-	struct jabber_data *jd = ic->proto_data;
 	struct jabber_buddy *bud;
 	
-	if( strchr( who, '/' ) )
-		bud = jabber_buddy_by_jid( ic, who, 0 );
-	else
-	{
-		char *s = jabber_normalize( who );
-		bud = g_hash_table_lookup( jd->buddies, s );
-		g_free( s );
-	}
+	bud = jabber_buddy_by_jid( ic, who, GET_BUDDY_FIRST );
 	
 	while( bud )
Index: protocols/jabber/jabber.h
===================================================================
--- protocols/jabber/jabber.h	(revision a81d679654e36055ce9913cd7541885b41380947)
+++ protocols/jabber/jabber.h	(revision 767a148faa35c18cdf4da77b5919a2f6e2df868a)
@@ -120,4 +120,11 @@
 };
 
+/* Somewhat messy data structure: We have a hash table with the bare JID as
+   the key and the head of a struct jabber_buddy list as the value. The head
+   is always a bare JID. If the JID has other resources (often the case,
+   except for some transports that don't support multiple resources), those
+   follow. In that case, the bare JID at the beginning doesn't actually
+   refer to a real session and should only be used for operations that
+   support incomplete JIDs. */
 struct jabber_buddy
 {
@@ -134,5 +141,5 @@
 	GSList *features;
 	
-	time_t last_act;
+	time_t last_msg;
 	jabber_buddy_flags_t flags;
 	
@@ -271,4 +278,6 @@
 	GET_BUDDY_EXACT = 2,	/* Get an exact match (only makes sense with bare JIDs). */
 	GET_BUDDY_FIRST = 4,	/* No selection, simply get the first resource for this JID. */
+	GET_BUDDY_BARE = 8,	/* Get the bare version of the JID (possibly inexistent). */
+	GET_BUDDY_BARE_OK = 16,	/* Allow returning a bare JID if that seems better. */
 } get_buddy_flags_t;
 
Index: protocols/jabber/jabber_util.c
===================================================================
--- protocols/jabber/jabber_util.c	(revision a81d679654e36055ce9913cd7541885b41380947)
+++ protocols/jabber/jabber_util.c	(revision 767a148faa35c18cdf4da77b5919a2f6e2df868a)
@@ -4,5 +4,5 @@
 *  Jabber module - Misc. stuff                                              *
 *                                                                           *
-*  Copyright 2006 Wilmer van der Gaast <wilmer@gaast.net>                   *
+*  Copyright 2006-2010 Wilmer van der Gaast <wilmer@gaast.net>              
 *                                                                           *
 *  This program is free software; you can redistribute it and/or modify     *
@@ -349,4 +349,9 @@
 	if( ( bud = g_hash_table_lookup( jd->buddies, full_jid ) ) )
 	{
+		/* The first entry is always a bare JID. If there are more, we
+		   should ignore the first one here. */
+		if( bud->next )
+			bud = bud->next;
+		
 		/* If this is a transport buddy or whatever, it can't have more
 		   than one instance, so this is always wrong: */
@@ -383,8 +388,13 @@
 	else
 	{
-		/* Keep in mind that full_jid currently isn't really
-		   a full JID... */
-		new->bare_jid = g_strdup( full_jid );
+		new->full_jid = new->bare_jid = g_strdup( full_jid );
 		g_hash_table_insert( jd->buddies, new->bare_jid, new );
+		
+		if( s )
+		{
+			new->next = g_new0( struct jabber_buddy, 1 );
+			new->next->bare_jid = new->bare_jid;
+			new = new->next;
+		}
 	}
 	
@@ -412,5 +422,5 @@
 {
 	struct jabber_data *jd = ic->proto_data;
-	struct jabber_buddy *bud;
+	struct jabber_buddy *bud, *head;
 	char *s, *jid;
 	
@@ -424,4 +434,9 @@
 		if( ( bud = g_hash_table_lookup( jd->buddies, jid ) ) )
 		{
+			bare_exists = 1;
+			
+			if( bud->next )
+				bud = bud->next;
+			
 			/* Just return the first one for this bare JID. */
 			if( flags & GET_BUDDY_FIRST )
@@ -445,14 +460,7 @@
 					break;
 		}
-		else
-		{
-			/* This variable tells the if down here that the bare
-			   JID already exists and we should feel free to add
-			   more resources, if the caller asked for that. */
-			bare_exists = 1;
-		}
 		
 		if( bud == NULL && ( flags & GET_BUDDY_CREAT ) &&
-		    ( !bare_exists || imcb_find_buddy( ic, jid ) ) )
+		    ( bare_exists || imcb_find_buddy( ic, jid ) ) )
 		{
 			*s = '/';
@@ -468,5 +476,6 @@
 		char *set;
 		
-		bud = g_hash_table_lookup( jd->buddies, jid );
+		head = g_hash_table_lookup( jd->buddies, jid );
+		bud = ( head && head->next ) ? head->next : head;
 		
 		g_free( jid );
@@ -485,4 +494,6 @@
 			/* Looks like the caller doesn't care about details. */
 			return bud;
+		else if( flags & GET_BUDDY_BARE )
+			return head;
 		
 		best_prio = best_time = bud;
@@ -491,5 +502,5 @@
 			if( bud->priority > best_prio->priority )
 				best_prio = bud;
-			if( bud->last_act > best_time->last_act )
+			if( bud->last_msg > best_time->last_msg )
 				best_time = bud;
 		}
@@ -497,8 +508,15 @@
 		if( ( set = set_getstr( &ic->acc->set, "resource_select" ) ) == NULL )
 			return NULL;
-		else if( strcmp( set, "activity" ) == 0 )
+		else if( strcmp( set, "priority" ) == 0 )
+			return best_prio;
+		else if( flags & GET_BUDDY_BARE_OK ) /* && strcmp( set, "activity" ) == 0 */
+		{
+			if( best_time->last_msg + set_getint( &ic->acc->set, "activity_timeout" ) >= time( NULL ) )
+				return best_time;
+			else
+				return head;
+		}
+		else
 			return best_time;
-		else /* if( strcmp( set, "priority" ) == 0 ) */
-			return best_prio;
 	}
 }
@@ -542,5 +560,5 @@
 {
 	struct jabber_data *jd = ic->proto_data;
-	struct jabber_buddy *bud, *prev, *bi;
+	struct jabber_buddy *bud, *prev = NULL, *bi;
 	char *s, *full_jid;
 	
@@ -552,4 +570,7 @@
 	if( ( bud = g_hash_table_lookup( jd->buddies, full_jid ) ) )
 	{
+		if( bud->next )
+			bud = (prev=bud)->next;
+		
 		/* If there's only one item in the list (and if the resource
 		   matches), removing it is simple. (And the hash reference
@@ -559,14 +580,5 @@
 		      ( bud->resource && s && strcmp( bud->resource, s + 1 ) == 0 ) ) )
 		{
-			g_hash_table_remove( jd->buddies, bud->bare_jid );
-			g_free( bud->bare_jid );
-			g_free( bud->ext_jid );
-			g_free( bud->full_jid );
-			g_free( bud->away_message );
-			g_free( bud );
-			
-			g_free( full_jid );
-			
-			return 1;
+			return jabber_buddy_remove_bare( ic, full_jid );
 		}
 		else if( s == NULL || bud->resource == NULL )
@@ -579,5 +591,5 @@
 		else
 		{
-			for( bi = bud, prev = NULL; bi; bi = (prev=bi)->next )
+			for( bi = bud; bi; bi = (prev=bi)->next )
 				if( strcmp( bi->resource, s + 1 ) == 0 )
 					break;
@@ -590,6 +602,5 @@
 					prev->next = bi->next;
 				else
-					/* The hash table should point at the second
-					   item, because we're removing the first. */
+					/* Don't think this should ever happen anymore. */
 					g_hash_table_replace( jd->buddies, bi->bare_jid, bi->next );
 				
Index: protocols/jabber/message.c
===================================================================
--- protocols/jabber/message.c	(revision a81d679654e36055ce9913cd7541885b41380947)
+++ protocols/jabber/message.c	(revision 767a148faa35c18cdf4da77b5919a2f6e2df868a)
@@ -71,5 +71,5 @@
 			if( bud )
 			{
-				bud->last_act = time( NULL );
+				bud->last_msg = time( NULL );
 				from = bud->ext_jid ? : bud->bare_jid;
 			}
Index: protocols/jabber/presence.c
===================================================================
--- protocols/jabber/presence.c	(revision a81d679654e36055ce9913cd7541885b41380947)
+++ protocols/jabber/presence.c	(revision 767a148faa35c18cdf4da77b5919a2f6e2df868a)
@@ -68,7 +68,4 @@
 		{
 			bud->away_state = NULL;
-			/* Let's only set last_act if there's *no* away state,
-			   since it could be some auto-away thingy. */
-			bud->last_act = time( NULL );
 		}
 		
